#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out vec3 TexCoords;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix;
uniform mat4 minViewMatrix;
uniform mat4 projMatrix;
uniform mat3 normalMatrix;

void main() {
	 TexCoords = position;
    vec4 pos = projMatrix * minViewMatrix * vec4(position, 1.0);
	gl_Position = pos.xyww;
}